﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using System.IO;
using System.Windows.Xps.Packaging;
using System.IO.Packaging;
using System.Windows.Xps.Serialization;


namespace XamdatachartExample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ViewModel vm = new ViewModel();
            this.DataContext = vm;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            FrameworkElement fe = (this.Chart as FrameworkElement);
            //Scale to A4 Page
            double scale = Math.Min(768/fe.ActualWidth,1016/fe.ActualHeight);

            fe.LayoutTransform = new ScaleTransform(scale, scale);
            fe.Measure(new Size(Int32.MaxValue, Int32.MaxValue));
            Size visualSize = fe.DesiredSize;
            //if (fe.DesiredSize.Width >= fe.ActualWidth || fe.DesiredSize.Height >= fe.ActualHeight)
                fe.Arrange(new Rect(new Point(0, 0), visualSize));
            MemoryStream stream = new MemoryStream();
            string pack = "pack://temp.xps";
            Uri uri = new Uri(pack);
            DocumentPaginator paginator;
            XpsDocument xpsDoc;
            DocumentViewer doc = new DocumentViewer();
            Window _window = new Window();

            //Adding dispatcher to dealy printing, so the chart can be meassured and arranged correctly.
            Dispatcher.BeginInvoke(new Action(() => 
            {
                using (Package container = Package.Open(stream, FileMode.Create))
                {
                    PackageStore.AddPackage(uri, container);
                    using (xpsDoc = new XpsDocument(container, CompressionOption.Fast, pack))
                    {
                        XpsSerializationManager rsm =
                          new XpsSerializationManager(new XpsPackagingPolicy(xpsDoc), false);
                        rsm.SaveAsXaml(this.Chart.Content);


                        paginator = ((IDocumentPaginatorSource)
                         xpsDoc.GetFixedDocumentSequence()).DocumentPaginator;

                        paginator.PageSize = visualSize;

                        doc.Document = xpsDoc.GetFixedDocumentSequence();

                        _window.Content = doc;
                        _window.ShowDialog();

                    }

                    PackageStore.RemovePackage(uri);
                }
            }), System.Windows.Threading.DispatcherPriority.Background, null);

        }
    }
}
